# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class MaestroWebhooksInvocationTopicWebhooksInvocation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        MaestroWebhooksInvocationTopicWebhooksInvocation - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'body': 'object',
            'headers': 'dict(str, list[str])',
            'query': 'dict(str, list[str])'
        }

        self.attribute_map = {
            'body': 'body',
            'headers': 'headers',
            'query': 'query'
        }

        self._body = None
        self._headers = None
        self._query = None

    @property
    def body(self) -> object:
        """
        Gets the body of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :return: The body of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :rtype: object
        """
        return self._body

    @body.setter
    def body(self, body: object) -> None:
        """
        Sets the body of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :param body: The body of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :type: object
        """
        

        self._body = body

    @property
    def headers(self) -> List[str]:
        """
        Gets the headers of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :return: The headers of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :rtype: dict(str, list[str])
        """
        return self._headers

    @headers.setter
    def headers(self, headers: List[str]) -> None:
        """
        Sets the headers of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :param headers: The headers of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :type: dict(str, list[str])
        """
        

        self._headers = headers

    @property
    def query(self) -> List[str]:
        """
        Gets the query of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :return: The query of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :rtype: dict(str, list[str])
        """
        return self._query

    @query.setter
    def query(self, query: List[str]) -> None:
        """
        Sets the query of this MaestroWebhooksInvocationTopicWebhooksInvocation.


        :param query: The query of this MaestroWebhooksInvocationTopicWebhooksInvocation.
        :type: dict(str, list[str])
        """
        

        self._query = query

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

