# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ConversationNormalizedMessage
    from . import SocialMediaMessageEscalationInfo

class SocialMediaDetailMessageContainer(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        SocialMediaDetailMessageContainer - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'normalized_message': 'ConversationNormalizedMessage',
            'escalation_info': 'SocialMediaMessageEscalationInfo'
        }

        self.attribute_map = {
            'id': 'id',
            'normalized_message': 'normalizedMessage',
            'escalation_info': 'escalationInfo'
        }

        self._id = None
        self._normalized_message = None
        self._escalation_info = None

    @property
    def id(self) -> str:
        """
        Gets the id of this SocialMediaDetailMessageContainer.


        :return: The id of this SocialMediaDetailMessageContainer.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this SocialMediaDetailMessageContainer.


        :param id: The id of this SocialMediaDetailMessageContainer.
        :type: str
        """
        

        self._id = id

    @property
    def normalized_message(self) -> 'ConversationNormalizedMessage':
        """
        Gets the normalized_message of this SocialMediaDetailMessageContainer.


        :return: The normalized_message of this SocialMediaDetailMessageContainer.
        :rtype: ConversationNormalizedMessage
        """
        return self._normalized_message

    @normalized_message.setter
    def normalized_message(self, normalized_message: 'ConversationNormalizedMessage') -> None:
        """
        Sets the normalized_message of this SocialMediaDetailMessageContainer.


        :param normalized_message: The normalized_message of this SocialMediaDetailMessageContainer.
        :type: ConversationNormalizedMessage
        """
        

        self._normalized_message = normalized_message

    @property
    def escalation_info(self) -> 'SocialMediaMessageEscalationInfo':
        """
        Gets the escalation_info of this SocialMediaDetailMessageContainer.


        :return: The escalation_info of this SocialMediaDetailMessageContainer.
        :rtype: SocialMediaMessageEscalationInfo
        """
        return self._escalation_info

    @escalation_info.setter
    def escalation_info(self, escalation_info: 'SocialMediaMessageEscalationInfo') -> None:
        """
        Sets the escalation_info of this SocialMediaDetailMessageContainer.


        :param escalation_info: The escalation_info of this SocialMediaDetailMessageContainer.
        :type: SocialMediaMessageEscalationInfo
        """
        

        self._escalation_info = escalation_info

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

